]> git.proxmox.com Git - rustc.git/blob - src/ci/run.sh
Merge branch 'debian/sid' into debian/experimental
[rustc.git] / src / ci / run.sh
1 #!/usr/bin/env bash
2
3 set -e
4
5 if [ -n "$CI_JOB_NAME" ]; then
6 echo "[CI_JOB_NAME=$CI_JOB_NAME]"
7 fi
8
9 if [ "$NO_CHANGE_USER" = "" ]; then
10 if [ "$LOCAL_USER_ID" != "" ]; then
11 useradd --shell /bin/bash -u $LOCAL_USER_ID -o -c "" -m user
12 export HOME=/home/user
13 unset LOCAL_USER_ID
14 exec su --preserve-environment -c "env PATH=$PATH \"$0\"" user
15 fi
16 fi
17
18 # only enable core dump on Linux
19 if [ -f /proc/sys/kernel/core_pattern ]; then
20 ulimit -c unlimited
21 fi
22
23 ci_dir=`cd $(dirname $0) && pwd`
24 source "$ci_dir/shared.sh"
25
26 branch_name=$(getCIBranch)
27
28 if [ ! isCI ] || [ "$branch_name" = "auto" ] || [ "$branch_name" = "try" ]; then
29 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --set build.print-step-timings --enable-verbose-tests"
30 fi
31
32 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-sccache"
33 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --disable-manage-submodules"
34 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-locked-deps"
35 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-cargo-native-static"
36 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --set rust.codegen-units-std=1"
37
38 if [ "$DIST_SRC" = "" ]; then
39 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --disable-dist-src"
40 fi
41
42 # If we're deploying artifacts then we set the release channel, otherwise if
43 # we're not deploying then we want to be sure to enable all assertions because
44 # we'll be running tests
45 #
46 # FIXME: need a scheme for changing this `nightly` value to `beta` and `stable`
47 # either automatically or manually.
48 export RUST_RELEASE_CHANNEL=stable
49 if [ "$DEPLOY$DEPLOY_ALT" = "1" ]; then
50 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --release-channel=$RUST_RELEASE_CHANNEL"
51 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-llvm-static-stdcpp"
52 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --set rust.remap-debuginfo"
53 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --debuginfo-level-std=1"
54
55 if [ "$NO_LLVM_ASSERTIONS" = "1" ]; then
56 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --disable-llvm-assertions"
57 elif [ "$DEPLOY_ALT" != "" ]; then
58 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-llvm-assertions"
59 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --set rust.verify-llvm-ir"
60 fi
61 else
62 # We almost always want debug assertions enabled, but sometimes this takes too
63 # long for too little benefit, so we just turn them off.
64 if [ "$NO_DEBUG_ASSERTIONS" = "" ]; then
65 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-debug-assertions"
66 fi
67
68 # In general we always want to run tests with LLVM assertions enabled, but not
69 # all platforms currently support that, so we have an option to disable.
70 if [ "$NO_LLVM_ASSERTIONS" = "" ]; then
71 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-llvm-assertions"
72 fi
73
74 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --set rust.verify-llvm-ir"
75 fi
76
77 if [ "$RUST_RELEASE_CHANNEL" = "nightly" ] || [ "$DIST_REQUIRE_ALL_TOOLS" = "" ]; then
78 RUST_CONFIGURE_ARGS="$RUST_CONFIGURE_ARGS --enable-missing-tools"
79 fi
80
81 # Print the date from the local machine and the date from an external source to
82 # check for clock drifts. An HTTP URL is used instead of HTTPS since on Azure
83 # Pipelines it happened that the certificates were marked as expired.
84 datecheck() {
85 echo "== clock drift check =="
86 echo -n " local time: "
87 date
88 echo -n " network time: "
89 curl -fs --head http://detectportal.firefox.com/success.txt | grep ^Date: \
90 | sed 's/Date: //g' || true
91 echo "== end clock drift check =="
92 }
93 datecheck
94 trap datecheck EXIT
95
96 # We've had problems in the past of shell scripts leaking fds into the sccache
97 # server (#48192) which causes Cargo to erroneously think that a build script
98 # hasn't finished yet. Try to solve that problem by starting a very long-lived
99 # sccache server at the start of the build, but no need to worry if this fails.
100 SCCACHE_IDLE_TIMEOUT=10800 sccache --start-server || true
101
102 if [ "$RUN_CHECK_WITH_PARALLEL_QUERIES" != "" ]; then
103 $SRC/configure --enable-parallel-compiler
104 CARGO_INCREMENTAL=0 python2.7 ../x.py check
105 rm -f config.toml
106 rm -rf build
107 fi
108
109 $SRC/configure $RUST_CONFIGURE_ARGS
110
111 retry make prepare
112
113 make check-bootstrap
114
115 # Display the CPU and memory information. This helps us know why the CI timing
116 # is fluctuating.
117 if isOSX; then
118 system_profiler SPHardwareDataType || true
119 sysctl hw || true
120 ncpus=$(sysctl -n hw.ncpu)
121 else
122 cat /proc/cpuinfo || true
123 cat /proc/meminfo || true
124 ncpus=$(grep processor /proc/cpuinfo | wc -l)
125 fi
126
127 if [ ! -z "$SCRIPT" ]; then
128 sh -x -c "$SCRIPT"
129 else
130 do_make() {
131 echo "make -j $ncpus $1"
132 make -j $ncpus $1
133 local retval=$?
134 return $retval
135 }
136
137 do_make "$RUST_CHECK_TARGET"
138 fi
139
140 sccache --show-stats || true